package Anglais;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JOptionPane;

public class ControleurCarte implements MouseListener {
	private Plateau modele;
	private Carte carte;

	public ControleurCarte(Plateau modele, Carte carte) {
		this.modele = modele;
		this.carte = carte;
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		JButton button = (JButton) e.getSource();
		
		if(button.isEnabled()) {
			if(!modele.getPlay().isRunning() && !modele.partieTerminee() && !modele.tempsEcoule())
				synchronized (modele.getPlay()) {
					modele.getPlay().setCarte(carte);
					modele.getPlay().notify();
				}

		} else if(modele.isCarte1(carte) && !modele.getDefinition(carte).equals("-")) {
			int points = Math.abs(modele.SCORE_DEF);
			
			if(JOptionPane.showConfirmDialog(null,
					"You're going to lose " + points + " point" + (points > 1 ? "s" : "") + " for viewing this clue.\nAre you sure?", "See clue",
					JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, new ImageIcon("icon_omg.png")) == JOptionPane.OK_OPTION) {
				
				modele.setScore(modele.getScore() + modele.SCORE_DEF);
				JOptionPane.showMessageDialog(null, modele.getDefinition(carte), "Clue", JOptionPane.INFORMATION_MESSAGE, new ImageIcon("icon_def.png"));
			}
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}