package Anglais;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JSlider;
import javax.swing.JTable;
import javax.swing.JToolBar;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import Anglais.Plateau.Game_t;

public class VueMenu extends JMenuBar {
	private static final long serialVersionUID = -4914949537621615616L;
	private Plateau modele;
	
	public VueMenu(Plateau modele) {
		this.modele = modele;

		JMenu menuPlay = new JMenu("Game");
		JMenu menuEditor = new JMenu("Editor");
		JMenu menuScore = new JMenu("Scores");

		JMenuItem menuPlayColors = new JMenuItem("Colors");
		JMenuItem menuPlayNumbers = new JMenuItem("Numbers");
		JMenuItem menuPlayPictures = new JMenuItem("Pictures");
		JMenuItem menuPlaySynonyms = new JMenuItem("Synonyms");
		JMenuItem menuPlayTranslate = new JMenuItem("Translations");
		
		menuPlayColors.setIcon(new ImageIcon("minicon_colors.png"));
		menuPlayNumbers.setIcon(new ImageIcon("minicon_numbers.png"));
		menuPlayPictures.setIcon(new ImageIcon("minicon_pictures.png"));
		menuPlaySynonyms.setIcon(new ImageIcon("minicon_synonyms.png"));
		menuPlayTranslate.setIcon(new ImageIcon("minicon_translate.png"));

		JMenuItem menuEditorColors = new JMenuItem("Colors");
		JMenuItem menuEditorNumbers = new JMenuItem("Numbers");
		JMenuItem menuEditorPictures = new JMenuItem("Pictures");
		JMenuItem menuEditorSynonyms = new JMenuItem("Synonyms");
		JMenuItem menuEditorTranslate = new JMenuItem("Translations");
		
		menuEditorColors.setIcon(new ImageIcon("minicon_edit.png"));
		menuEditorNumbers.setIcon(new ImageIcon("minicon_edit.png"));
		menuEditorPictures.setIcon(new ImageIcon("minicon_edit.png"));
		menuEditorSynonyms.setIcon(new ImageIcon("minicon_edit.png"));
		menuEditorTranslate.setIcon(new ImageIcon("minicon_edit.png"));
		
		JMenuItem menuScoreView = new JMenuItem("High scores");
		JMenuItem menuScoreReset = new JMenuItem("Reset");
		
		menuScoreView.setIcon(new ImageIcon("minicon_score.png"));
		menuScoreReset.setIcon(new ImageIcon("minicon_reset.png"));
		
		setBorderPainted(false);
		menuPlay.setBorderPainted(false);
		menuEditor.setBorderPainted(false);
		menuScore.setBorderPainted(false);
		
		final Plateau fmodele = modele;
		
		menuPlaySynonyms.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.SYNONYMES);
				selectTaillePlateau();
			}
		});
		
		menuEditorSynonyms.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.SYNONYMES);
				selectEditor();
			}
		});
		
		menuPlayTranslate.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.TRANSLATE);
				selectTaillePlateau();
			}
		});
		
		menuEditorTranslate.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.TRANSLATE);
				selectEditor();
			}
		});
		
		menuPlayColors.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.COLORS);
				selectTaillePlateau();
			}
		});
		
		menuEditorColors.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.COLORS);
				selectEditor();
			}
		});
		
		menuPlayNumbers.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.NUMBERS);
				selectTaillePlateau();
			}
		});
		
		menuEditorNumbers.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.NUMBERS);
				selectEditor();
			}
		});
		
		menuPlayPictures.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.PICTURES);
				selectTaillePlateau();
			}
		});
		
		menuEditorPictures.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				fmodele.setGame_t(Game_t.PICTURES);
				selectEditor();
			}
		});
		
		menuScoreView.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				voirMeilleurScore();
			}
		});
		
		menuScoreReset.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				resetMeilleurScore();
			}
		});

		menuPlay.add(menuPlayColors);
		menuPlay.add(menuPlayNumbers);
		menuPlay.add(menuPlayPictures);
		menuPlay.add(menuPlaySynonyms);
		menuPlay.add(menuPlayTranslate);

		menuEditor.add(menuEditorColors);
		menuEditor.add(menuEditorNumbers);
		menuEditor.add(menuEditorPictures);
		menuEditor.add(menuEditorSynonyms);
		menuEditor.add(menuEditorTranslate);

		menuScore.add(menuScoreView);
		menuScore.add(menuScoreReset);
		
		add(menuPlay);
		add(menuEditor);
		add(menuScore);
	}

	public void selectTaillePlateau() {
		Object[] options = { "Play", "Cancel" };
		JSlider taillePlateau = new JSlider(JSlider.HORIZONTAL, 1, 10, 1);
		
		modele.setSetLevel(false);
		
		JComponent[] inputs  = {
				new JLabel("Start level:"),
				taillePlateau,
				new JLabel(" "),
				new JLabel("Player name:"),
		};
	
		taillePlateau.setMajorTickSpacing(2);
		taillePlateau.setMinorTickSpacing(1);
		taillePlateau.setPaintTicks(true);
		taillePlateau.setPaintLabels(true);
		taillePlateau.setSnapToTicks(true);
	
		taillePlateau.addChangeListener(new ChangeListener() {
			@Override
			public void stateChanged(ChangeEvent e) {
				modele.setLevel(((JSlider) e.getSource()).getValue() - 1);
				modele.setSetLevel(true);
			}
		});
	
		JOptionPane dialogPan = new JOptionPane(
			inputs,
			JOptionPane.PLAIN_MESSAGE,
			2, new ImageIcon("icon.png"),
			options,
			null
		);
	
		dialogPan.setWantsInput(true);
		JDialog dialog = dialogPan.createDialog("Launch");

		dialog.setVisible(true);
		dialog.dispose();
	
		if(dialogPan.getValue() != null && dialogPan.getValue() != options[1]) {			
			if(((String) dialogPan.getInputValue()).isEmpty()) {
				JOptionPane.showMessageDialog(null, "The player name is required.", "Name required", JOptionPane.WARNING_MESSAGE, new ImageIcon("icon_name.png"));
				selectTaillePlateau();

			} else {
				if(!modele.isSetLevel())
					modele.setLevel(0);
				
				modele.setName((String) dialogPan.getInputValue());
				modele.start();
			}
		}
	}
	
	public void selectEditor() {
        String[] columnNames = {"Word1",  "Word2", "Definition" };

        JTable editor = new JTable();
        final Editor editorModel = new Editor(columnNames, editor);
        ArrayList<String[]> data = new ArrayList<String[]>();

        editor.setModel(editorModel);
        editor.setSurrendersFocusOnKeystroke(true);
        editor.setFillsViewportHeight(true);

        JScrollPane scroller = new JScrollPane(editor);
        editor.setPreferredScrollableViewportSize(new java.awt.Dimension(500, 300));

        JButton toSave = new JButton("Save");
        JButton toExit = new JButton("Close");
        JButton toImport = new JButton("Import");
        JButton toExport = new JButton("Export");
        
        toSave.setIcon(new ImageIcon("icon_save.png"));
        toExit.setIcon(new ImageIcon("icon_exit.png"));
        toImport.setIcon(new ImageIcon("icon_import.png"));
        toExport.setIcon(new ImageIcon("icon_export.png"));
                
        JPanel panel = new JPanel(new BorderLayout());
        
        JToolBar buttons = new JToolBar();
        buttons.add(toSave);
        buttons.add(toImport);
        buttons.add(toExport);
        buttons.add(new JSeparator());
        buttons.add(toExit);
        
        panel.add(buttons, BorderLayout.NORTH);
        panel.add(scroller, BorderLayout.CENTER);
		        
		JOptionPane dialogPan = new JOptionPane(
			new JComponent[] { panel },
			JOptionPane.PLAIN_MESSAGE,
			2, new ImageIcon("icon_editor.png"),
			new String[]{}, null
		);
		
		final JDialog dialog = dialogPan.createDialog("Editor");

		toImport.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				JFileChooser fc = new JFileChooser();
				fc.setDialogTitle("Import a game file");

				if(fc.showOpenDialog(null) != JFileChooser.CANCEL_OPTION) {
					editorModel.loadDataFromFile(fc.getSelectedFile());
					editorModel.exportData(new File(modele.getFile()));

					dialog.dispose();
					selectEditor();
				}
			}
		});
		
		toExport.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				JFileChooser fc = new JFileChooser();
				fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
				fc.setDialogTitle("Export a game file");

				if(fc.showSaveDialog(null) != JFileChooser.CANCEL_OPTION)
					editorModel.exportData(fc.getSelectedFile());
			}
		});
		
        toSave.addActionListener(new ActionListener() {			
			@Override
			public void actionPerformed(ActionEvent e) {
				editorModel.exportData(new File(modele.getFile()));
			}
		});
        
        toExit.addActionListener(new ActionListener() {			
			@Override
			public void actionPerformed(ActionEvent e) {
				dialog.dispose();
			}
		});

		editorModel.setData(data);
    	editor.getColumn("Definition").setMinWidth(200);
    	editorModel.loadDataFromFile(new File(modele.getFile()));
    	editorModel.addEmptyRow();

		dialog.setSize(600, 400);
		dialog.setVisible(true);
		dialog.dispose();
	}
	
	public void voirMeilleurScore() {
		String[] synonyms = modele.getMeilleurScore(Game_t.SYNONYMES);
		String[] translate = modele.getMeilleurScore(Game_t.TRANSLATE);
		String[] colors = modele.getMeilleurScore(Game_t.COLORS);
		String[] numbers = modele.getMeilleurScore(Game_t.NUMBERS);
		String[] pictures = modele.getMeilleurScore(Game_t.PICTURES);
		
		String msg = "Colors:\n" + colors[0] + " with " + colors[1] + " point" + (Integer.parseInt(colors[1]) > 1 ? "s" : "") + " (level " + colors[2] + ")\n\n"
				+ "Numbers:\n" + numbers[0] + " with " + numbers[1] + " point" + (Integer.parseInt(numbers[1]) > 1 ? "s" : "") + " (level " + numbers[2] + ")\n\n"
				+ "Pictures:\n" + pictures[0] + " with " + pictures[1] + " point" + (Integer.parseInt(pictures[1]) > 1 ? "s" : "") + " (level " + pictures[2] + ")\n\n"
				+ "Synonyms:\n" + synonyms[0] + " with " + synonyms[1] + " point" + (Integer.parseInt(synonyms[1]) > 1 ? "s" : "") + " (level " + synonyms[2] + ")\n\n"
				+ "Translate:\n" + translate[0] + " with " + translate[1] + " point" + (Integer.parseInt(translate[1]) > 1 ? "s" : "") + " (level " + translate[2] + ")";
		
		JOptionPane.showMessageDialog(null, msg, "High scores", JOptionPane.INFORMATION_MESSAGE, new ImageIcon("icon_score.png"));
	}
	
	public void resetMeilleurScore() {
		if(JOptionPane.showConfirmDialog(null,
				"Delete all high scores.\nAre you sure?", "Delete all high score",
				JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, new ImageIcon("icon_omg.png")) == JOptionPane.OK_OPTION) {

			modele.saveMeilleurScore(Game_t.SYNONYMES, "Nobody", 0, 0);
			modele.saveMeilleurScore(Game_t.TRANSLATE, "Nobody", 0, 0);
			modele.saveMeilleurScore(Game_t.COLORS, "Nobody", 0, 0);
			modele.saveMeilleurScore(Game_t.NUMBERS, "Nobody", 0, 0);
			modele.saveMeilleurScore(Game_t.PICTURES, "Nobody", 0, 0);
		}
	}
}